 EnableExplicit


Structure strAppSetup
  ScreenWidth.l
  ScreenHeight.l
  ScreenDeep.l
  ScreenOffsetY.l
  ScreenOffsetX.l
  WindowWidth.l
  WindowHeight.l
  WithPic.l
  Fullscreen.l
  GameUpdateFreq.f
  LoopTimeStart.f
  tTime.f
  GameFrameSize.l
EndStructure

Structure strSpriteFont
  SpriteNo.l
  CharSizeX.l
  CharSizeY.l
EndStructure



Structure strSpider
  PosX.l
  PosY.l
  isPaint.l
  Direction.l
  PaintStartX.l
  PaintStartY.l
  Steps.f
EndStructure

Structure strBug
  BugType.l
  PosX.f
  PosY.f
  DirectionX.f
  DirectionY.f
  spr_Bug.l
  
  Steps.f
EndStructure

Structure strCollision
  X.l
  Y.l
  LastBefX.l
  LastBefY.l
  isCollision.l
EndStructure

Structure strFlyingText
  text.s
  PosX.l
  PosY.l
EndStructure

Structure strLevel
  TargetNetSizePerc.l
  BugCount.l
  ScorePerBug.l
  ScorePerPerc.l
  ScoreBigSizeMultiP.l
  ScoreMonsterSizeMultiP.l
  MaxBugSpeed.l
EndStructure


Global Dim Level.strLevel(200)
Global NewList ScoreText.strFlyingText()

Global tFieldSizeX.l=640
Global tFieldSizeY.l=460
Global FieldLeft.f=100
Global tDC.l
Global tExit.l

Global Dim spr_Bugs(2)


Global Spider.strSpider
Global NewList Bug.strBug()


Global LineColor.l=RGB(0,0,0)
Global NetColor.l=RGB(100,100,100)
Global FieldBGColor.l=RGB(255,255,255)

Global tFill1FieldPoints.l,tFill2FieldPoints.l
Global myFont1.strSpriteFont
Global myFont2.strSpriteFont

Global time.l,fps.l,Frames.l


Global AppInternals.strAppSetup


Global Lives.l=0
Global ActLevel.l=0


With AppInternals
  \ScreenOffsetX=0
  \ScreenOffsetY=20
  \ScreenWidth.l=640
  \ScreenHeight.l=480
  \WindowWidth.l=800;200;1024
  \WindowHeight.l=600;100;768
  \ScreenDeep.l=32
  \GameUpdateFreq=10
  \Fullscreen=0
  \WithPic=1
  \GameFrameSize=20
EndWith  


Enumeration
  #wnd_Main
  #spr_Spider
  #FieldImage
  #FieldSprite
  #spr_Fly
  #bgImage
  #BackGroundSprite
  #img_GameOver
  #img_StartImage
EndEnumeration

Declare isBugInNet()
Declare drawLevel()
Declare Died(Reason.l=0)


;-LevelDef
;{
With level(1)
  \TargetNetSizePerc=20
  \BugCount=3
  \ScorePerBug=300
  \ScorePerPerc=10
  \ScoreBigSizeMultiP=2
  \ScoreMonsterSizeMultiP=4
  \MaxBugSpeed=3
EndWith

With level(2)
  \TargetNetSizePerc=30
  \BugCount=4
  \ScorePerBug=300
  \ScorePerPerc=10
  \ScoreBigSizeMultiP=2
  \ScoreMonsterSizeMultiP=4
  \MaxBugSpeed=3
EndWith

With level(3)
  \TargetNetSizePerc=35
  \BugCount=4
  \ScorePerBug=300
  \ScorePerPerc=10
  \ScoreBigSizeMultiP=2
  \ScoreMonsterSizeMultiP=4
  \MaxBugSpeed=3
EndWith

With level(4)
  \TargetNetSizePerc=40
  \BugCount=4
  \ScorePerBug=300
  \ScorePerPerc=10
  \ScoreBigSizeMultiP=2
  \ScoreMonsterSizeMultiP=4
  \MaxBugSpeed=4
EndWith

With level(5)
  \TargetNetSizePerc=45
  \BugCount=4
  \ScorePerBug=300
  \ScorePerPerc=10
  \ScoreBigSizeMultiP=2
  \ScoreMonsterSizeMultiP=4
  \MaxBugSpeed=4
EndWith

With level(6)
  \TargetNetSizePerc=55
  \BugCount=4
  \ScorePerBug=300
  \ScorePerPerc=10
  \ScoreBigSizeMultiP=2
  \ScoreMonsterSizeMultiP=4
  \MaxBugSpeed=4
EndWith

With level(7)
  \TargetNetSizePerc=45
  \BugCount=6
  \ScorePerBug=300
  \ScorePerPerc=10
  \ScoreBigSizeMultiP=2
  \ScoreMonsterSizeMultiP=4
  \MaxBugSpeed=3
EndWith

With level(8)
  \TargetNetSizePerc=55
  \BugCount=6
  \ScorePerBug=300
  \ScorePerPerc=10
  \ScoreBigSizeMultiP=2
  \ScoreMonsterSizeMultiP=4
  \MaxBugSpeed=3
EndWith

With level(9)
  \TargetNetSizePerc=80
  \BugCount=4
  \ScorePerBug=300
  \ScorePerPerc=10
  \ScoreBigSizeMultiP=2
  \ScoreMonsterSizeMultiP=4
  \MaxBugSpeed=3
EndWith

With level(10)
  \TargetNetSizePerc=80
  \BugCount=5
  \ScorePerBug=300
  \ScorePerPerc=10
  \ScoreBigSizeMultiP=2
  \ScoreMonsterSizeMultiP=4
  \MaxBugSpeed=4
EndWith

With level(11)
  \TargetNetSizePerc=55
  \BugCount=10
  \ScorePerBug=300
  \ScorePerPerc=10
  \ScoreBigSizeMultiP=2
  \ScoreMonsterSizeMultiP=4
  \MaxBugSpeed=3
EndWith

With level(12)
  \TargetNetSizePerc=75
  \BugCount=10
  \ScorePerBug=300
  \ScorePerPerc=10
  \ScoreBigSizeMultiP=2
  \ScoreMonsterSizeMultiP=4
  \MaxBugSpeed=4
EndWith

With level(13)
  \TargetNetSizePerc=80
  \BugCount=10
  \ScorePerBug=300
  \ScorePerPerc=10
  \ScoreBigSizeMultiP=2
  \ScoreMonsterSizeMultiP=4
  \MaxBugSpeed=4
EndWith


With level(14)
  \TargetNetSizePerc=70
  \BugCount=12
  \ScorePerBug=300
  \ScorePerPerc=10
  \ScoreBigSizeMultiP=2
  \ScoreMonsterSizeMultiP=4
  \MaxBugSpeed=4
EndWith

With level(15)
  \TargetNetSizePerc=85
  \BugCount=12
  \ScorePerBug=300
  \ScorePerPerc=10
  \ScoreBigSizeMultiP=2
  \ScoreMonsterSizeMultiP=4
  \MaxBugSpeed=4
EndWith


With level(16)
  \TargetNetSizePerc=65
  \BugCount=14
  \ScorePerBug=300
  \ScorePerPerc=10
  \ScoreBigSizeMultiP=2
  \ScoreMonsterSizeMultiP=4
  \MaxBugSpeed=4
EndWith

With level(17)
  \TargetNetSizePerc=75
  \BugCount=15
  \ScorePerBug=300
  \ScorePerPerc=10
  \ScoreBigSizeMultiP=2
  \ScoreMonsterSizeMultiP=4
  \MaxBugSpeed=4
EndWith

;}


Procedure.l CheckForCollision(*mycollision.strCollision,x1, y1, x2, y2,tColor)
Protected StepX.l,StepY.l,tExit.l=#False,tlastx.l,tlasty.l
  *mycollision\LastBefX=tLastX
  *mycollision\LastBefY=tLastY
  *mycollision\isCollision=0
  
  If x1<>x2 And y1<>y2
    If x1<x2
      StepX=1
    Else
      StepX=-1
    EndIf
    
    If Y1<Y2
      StepY=1
    Else
      StepY=-1
    EndIf
  
    *mycollision\x=x1
    *mycollision\y=y1
    *mycollision\LastBefX=x1
    *mycollision\LastBefX=y1
    Repeat
      *mycollision\LastBefX=*mycollision\x
      *mycollision\LastBefY=*mycollision\y
      *mycollision\x=*mycollision\x+StepX
      *mycollision\Y=*mycollision\Y+StepY
    
      If Point(*mycollision\x,*mycollision\y)=tColor
        *mycollision\isCollision=1
      EndIf
    Until *mycollision\x=x2 Or *mycollision\x=y2 Or *mycollision\isCollision=1
    If *mycollision\isCollision=0
       *mycollision\LastBefX=0
       *mycollision\LastBefY=0
       *mycollision\x=0
       *mycollision\y=0
       *mycollision\isCollision=0
    EndIf
  EndIf
ProcedureReturn *mycollision\isCollision
EndProcedure


Procedure InitGameTimer() 
Protected _GT_DevCaps.TIMECAPS 
  timeGetDevCaps_(_GT_DevCaps,SizeOf(TIMECAPS)) 
  timeBeginPeriod_(_GT_DevCaps\wPeriodMin) 
EndProcedure 


Procedure StopGameTimer() 
Protected _GT_DevCaps.TIMECAPS 
  timeEndPeriod_(_GT_DevCaps\wPeriodMin) 
EndProcedure 


Procedure DrawTransparentImage(DC, ImageID, x, y, TransparentColor) 
Protected ImageList, BM.BITMAP 
  GetObject_(ImageID, SizeOf(BITMAP), BM.BITMAP) 
  ImageID = CopyImage_(ImageID, #IMAGE_BITMAP, BM\bmWidth, BM\bmHeight, 0) 
  ImageList = ImageList_Create_(BM\bmWidth, BM\bmHeight, #ILC_COLORDDB|#ILC_MASK, 1, 0) 
  ImageList_AddMasked_(ImageList, ImageID, TransparentColor) 
  ImageList_Draw_(ImageList, 0, DC, x, y, #ILD_TRANSPARENT) 
  ImageList_Destroy_(ImageList) 
  DeleteObject_(ImageID) 
EndProcedure 


Procedure.l vsFillArea( X.l, Y.l,  Color.l ) 
Protected Width.w = tFieldSizeX
Protected Height.w = tFieldSizeY 
Protected NoOfPoints.l=0
Protected Dim Done.b(Width-1, Height-1) 
Protected NewList Recursive.Point() 
Protected tRGB=Point(X, Y)
Protected Point.l 
 
  AddElement(Recursive()) 
  Recursive()\X = X 
  Recursive()\Y = Y 
  
  Repeat 
    X = Recursive()\X 
    Y = Recursive()\Y 
    Point = Point(X, Y) 
    
    DeleteElement(Recursive()) 
    
    If Done(X, Y) = 0 
      If Point=tRGB 
        tRGB=Point
        Done(X, Y) = 1 
        
        Plot(X, Y, Color) 
        NoOfPoints=NoOfPoints+1
        If X > 0 
          If Done(X-1, Y) = 0 
            AddElement(Recursive()) 
            Recursive()\X = X-1 
            Recursive()\Y = Y 
          EndIf 
        EndIf 
        If X < Width-1 
          If Done(X+1, Y) = 0 
            AddElement(Recursive()) 
            Recursive()\X = X+1 
            Recursive()\Y = Y 
          EndIf 
        EndIf 
        If Y > 0 
          If Done(X, Y-1) = 0 
            AddElement(Recursive()) 
            Recursive()\X = X 
            Recursive()\Y = Y-1 
          EndIf 
        EndIf 
        If Y < Height-1 
          If Done(X, Y+1) = 0 
            AddElement(Recursive()) 
            Recursive()\X = X 
            Recursive()\Y = Y+1 
          EndIf 
        EndIf 
      Else 
        Done(X, Y) = 1 
      EndIf 
    EndIf 
    
  Until CountList(Recursive()) = 0 
  ProcedureReturn NoOfPoints
EndProcedure 


Procedure Open_wnd_main() 
 If  AppInternals\Fullscreen=1
   OpenScreen(AppInternals\ScreenWidth,AppInternals\ScreenHeight,AppInternals\ScreenDeep,"Mr. Spider")
 Else
  If OpenWindow(#wnd_Main, 1, 1, AppInternals\WindowWidth, AppInternals\WindowHeight, "Mr. Spider",  #PB_Window_SystemMenu | #PB_Window_SizeGadget | #PB_Window_TitleBar )
    OpenWindowedScreen(WindowID(#wnd_Main),0,0,AppInternals\ScreenWidth,AppInternals\ScreenHeight,1,0,0)
  EndIf
 EndIf
EndProcedure


Procedure vsLoadSpriteFont(*tSpriteFont.strSpriteFont,tFile.s,CharSizeX.l, CharSizeY.l)
Protected tCol.l
  *tSpriteFont\SpriteNo=LoadSprite(#PB_Any, tFile.s , 0 )
  StartDrawing(SpriteOutput(*tSpriteFont\SpriteNo))
  tCol=Point(0,0)
  StopDrawing()
  TransparentSpriteColor(*tSpriteFont\SpriteNo,tCol)
  *tSpriteFont\CharSizeX=CharSizeX
  *tSpriteFont\CharSizeY=CharSizeY
EndProcedure


Procedure vsDrawSpriteText(*tSpriteFont.strSpriteFont,x.l, y.l, Text.s)
Protected tCount=0,buff.b
  Repeat
    buff = PeekB(@Text+tCount)
    ClipSprite(*tSpriteFont\SpriteNo,(buff-32)*(*tSpriteFont\CharSizeX), 0, *tSpriteFont\CharSizeX, *tSpriteFont\CharSizeY)
    DisplayTransparentSprite(*tSpriteFont\SpriteNo, x+(tCount*(*tSpriteFont\CharSizeX)), y)
    tCount+1
  Until buff = 0
EndProcedure


Procedure vsDrawWaveText(*tSpriteFont.strSpriteFont,x.l, y.l, Text.s)
Protected tPos.l
Static t.l
  t=t+1
  If t=20:t=1:EndIf
  
  ;Debug Str(t)+":   "+Str(Sin(tpos+t)*10)
  For tPos=1 To Len(text)
      vsDrawSpriteText(*tSpriteFont,x+(tPos-1)**tSpriteFont\CharSizeX,y+Sin(tpos+t)*5, Mid(text,tPos,1))
  Next
EndProcedure


Procedure ChooseTextStyle(*tSpriteFont.strSpriteFont,x.l, y.l, Text.s,Style.l)
  If Style=1
    vsDrawWaveText(*tSpriteFont,x.l, y.l, Text.s)
  Else
    vsDrawSpriteText(*tSpriteFont,x.l, y.l, Text.s)
  EndIf
EndProcedure


Procedure NewScoreText(tText.s)
AddElement(ScoreText())
  ScoreText()\PosY=tFieldSizeY/2
  ScoreText()\PosX=tFieldSizeX/2
  ScoreText()\text=tText
EndProcedure


Procedure GoRollText()
  ForEach ScoreText()  
    ScoreText()\PosY=ScoreText()\PosY-1
    vsDrawSpriteText(@myFont1,ScoreText()\PosX, ScoreText()\PosY, ScoreText()\text)
    If ScoreText()\PosY=0
      DeleteElement(ScoreText())
    EndIf
  Next
EndProcedure


Procedure isSideBlock(x.l,y.l)
Protected tsideBlocked=0
;Checks if something is left or right in front
  If  Spider\Direction=1 And Point(X-1,Y-1)=netColor 
    tsideBlocked=-1
  ElseIf Spider\Direction=1 And Point(x+1,Y-1)=netColor
    tsideBlocked=1
  ElseIf  Spider\Direction=3 And Point(x-1,Y+1)=netColor 
    tsideBlocked=-1
  ElseIf  Spider\Direction=3 And Point(X+1,Y+1)=netColor
    tsideBlocked=1        
  ElseIf  Spider\Direction=2 And Point(X+1,Y-1)=netColor 
    tsideBlocked=-1
  ElseIf  Spider\Direction=2 And Point(X+1,Y+1)=netColor
    tsideBlocked=1
  ElseIf  Spider\Direction=4 And Point(X-1,Y-1)=netColor 
    tsideBlocked=-1
  ElseIf  Spider\Direction=4 And Point(X-1,Y+1)=netColor
    tsideBlocked=1
  EndIf
ProcedureReturn tsideBlocked 
EndProcedure


Procedure.l GoSpider()
Protected nextX,nextY
Protected tHit=0
Protected tDead=0
Protected tFillPoints.f=0
Protected tPercField.f=0
Protected tsideBlocked.l=0
Protected tFill1DirX.l,tFill1DirY.l,tFill2DirX.l,tFill2DirY.l ;starting Point for filling Field


  StartDrawing(ImageOutput(#FieldImage))
  
  ;Set next Step
  If Spider\Direction=1
    NextY=Spider\PosY-Spider\Steps
    NextX=Spider\PosX
  ElseIf Spider\Direction=2
    NextX=Spider\PosX+Spider\Steps
    NextY=Spider\PosY
  ElseIf Spider\Direction=3
    NextY=Spider\PosY+Spider\Steps
    NextX=Spider\PosX
  ElseIf Spider\Direction=4
    NextX=Spider\PosX-Spider\Steps
    NextY=Spider\PosY
  Else
    NextY=Spider\PosY
    NextX=Spider\PosX
  EndIf
  
  ;Spider hit it#s own rope
  If Point(NextX,NextY)=LineColor
   tDead=1
  EndIf
  
  ;Check if Spider hit the net not infront but at the side
  If isSideBlock(Spider\PosX,Spider\PosY)<>0 And Spider\isPaint=1 And Point(NextX,NextY)<>netColor And Point(Spider\PosX,Spider\PosY)<>netColor
    tsideBlocked=1
  EndIf
  
  
  ;Check if Spider hit the net
  If ((Point(NextX,NextY)=netColor Or Not (NextX>=0 And NextX<=tFieldSizeX-1 And NextY>=0 And NextY<=tFieldSizeY-1)   ) Or tSideBlocked) And Spider\isPaint=1
  
     LineXY(Spider\PosX,Spider\PosY,nextx,nexty,LineColor)
  
    ;Fill the drawen Line with netColor
    tFillPoints=vsFillArea( Spider\PosX, Spider\PosY, netColor)
    
    ;Get Position for StartFilling
    If Spider\Direction=1
      tFill1DirX=1
      tFill1DirY=1
      tFill2DirX=-1
      tFill2DirY=1
    ElseIf Spider\Direction=2
      tFill1DirX=-1
      tFill1DirY=-1
      tFill2DirX=-1
      tFill2DirY=1
    ElseIf Spider\Direction=3
      tFill1DirX=1
      tFill1DirY=-1
      tFill2DirX=-1
      tFill2DirY=-1
    ElseIf Spider\Direction=4
      tFill1DirX=1
      tFill1DirY=-1
      tFill2DirX=1
      tFill2DirY=1
    EndIf
    
    ;get the field size
    tFill1FieldPoints=vsFillArea( NextX+tFill1DirX,NextY+tFill1DirY, FieldBGColor ) 
    tFill2FieldPoints=vsFillArea( NextX+tFill2DirX,NextY+tFill2DirY, FieldBGColor ) 
    
    ;Check If a fields can be filled 
    If tFill1FieldPoints>0 And tFill2FieldPoints>0
    ;Compare Fields and use the smaler one
      If tFill1FieldPoints<tFill2FieldPoints
        FillArea(NextX+tFill1DirX,NextY+tFill1DirY, -1, netColor)
        tFillPoints=tFillPoints+tFill1FieldPoints
      ElseIf tFill1FieldPoints>tFill2FieldPoints
        FillArea(NextX+tFill2DirX,NextY+tFill2DirY, -1, netColor)
        tFillPoints=tFillPoints+tFill2FieldPoints
      Else ;Randomize if both are the same size
        tFillPoints=tFillPoints+tFill1FieldPoints
        Select Random(1)
          Case 0
            FillArea(NextX+tFill1DirX,NextY+tFill2DirY, -1, netColor)
          Case 1
            FillArea(NextX+tFill1DirX,NextY+tFill2DirY, -1, netColor)
        EndSelect  
      EndIf
      
      ;Check if a Bug is caught in the net
      isBugInNet()
    
      ;calculate the needed rest and check for an extra Live
      If tFillPoints>0
        tPercField=((100/((tFieldSizeX-AppInternals\GameFrameSize*2)*(tFieldSizeY-AppInternals\GameFrameSize*2)))*tFillPoints)
        If tPercField>20
          NewScoreText("EXTRA LIVE!!!!")
          Lives=Lives+1
        EndIf
        FieldLeft-((100/((tFieldSizeX-AppInternals\GameFrameSize*2)*(tFieldSizeY-AppInternals\GameFrameSize*2)))*tFillPoints)
      EndIf
    EndIf
    Spider\Direction=0
    Spider\isPaint=0
  ElseIf Point(NextX,NextY)=FieldBGColor And isSideBlock(Spider\PosX,Spider\PosY)=0
    If Spider\isPaint=0
      Spider\PaintStartX=NextX
      Spider\PaintStartY=NextY
    EndIf
    Spider\isPaint=1
  ElseIf Point(NextX,NextY)=FieldBGColor And isSideBlock(Spider\PosX,Spider\PosY)<>0
     If Spider\Direction=1 Or Spider\Direction=3
      nextx=nextx+isSideBlock(Spider\PosX,Spider\PosY)
     ElseIf Spider\Direction=2 Or Spider\Direction=4
      nextx=nextx+isSideBlock(Spider\PosX,Spider\PosY)
     EndIf 
  EndIf
   

;Check if Spider is in Field
  If (Not (NextX>=0 And NextX<=tFieldSizeX And NextY>=0 And NextY<=tFieldSizeY))
    ;Spider is not in Field leave Spider where it is and stop moving
    NextY=Spider\PosY
    NextX=Spider\PosX
    Spider\Direction=0
  EndIf
  
  
  ;Change spider Position to next position
  Spider\PosY=NextY
  Spider\PosX=NextX
  
  If Spider\isPaint=1
    LineXY(Spider\PosX,Spider\PosY,nextx,nexty,LineColor)
  EndIf

  ;Step next Step as actual ()
  ;Plot(Spider\PosX,Spider\PosY,LineColor)
  
  StopDrawing()
  If tDead=1
    died(1)
  EndIf
EndProcedure


Procedure Died(Reason.l=0)
  Lives=Lives-1
  If Lives>=0
    Repeat
      drawlevel()  
      vsDrawSpriteText(@myFont2, 50,AppInternals\Screenheight.l/2-60,"You Died!")
      If Reason=0
        vsDrawSpriteText(@myFont1, 50,AppInternals\Screenheight.l/2-20,"A bug hits your rope! ")
      ElseIf Reason=1
         vsDrawSpriteText(@myFont1, 50,AppInternals\Screenheight.l/2-20,"You hit your rope!")
      EndIf
      
      If Lives=0
        vsDrawSpriteText(@myFont1, 50,AppInternals\ScreenHeight.l/2,"This is your last live!!!")
      Else
        vsDrawSpriteText(@myFont1, 50,AppInternals\ScreenHeight.l/2,"You have still "+Str(Lives)+ " lives left!")
      EndIf
      vsDrawSpriteText(@myFont1, 50,AppInternals\ScreenHeight.l/2+30,"Have Fun!")
      vsDrawSpriteText(@myFont1, 50,AppInternals\ScreenHeight.l/2+60,"Press Space to Continue!")
      ExamineKeyboard()
      If AppInternals\Fullscreen=0; Update the Window if is in windowmode
        WindowEvent()
      EndIf
    Until KeyboardReleased(#PB_Key_Space)
    ;Delete Rope
    StartDrawing(ImageOutput(#FieldImage))
    FillArea(Spider\posX, Spider\PosY  , -1,FieldBGColor)
    StopDrawing()
    ;Set Spider to start position
    Spider\Direction=0
    Spider\PosX=tFieldSizeX/2
    Spider\PosY=tFieldSizeY
    Spider\Steps=1
    Spider\isPaint=0
  Else ;Game Over
    Repeat
      drawlevel() 
      DisplayTransparentSprite(#img_GameOver,200,200) 
      ;vsDrawSpriteText(@myFont2, 50,AppInternals\Screenheight.l/2-60,"Game Over!")
      ExamineKeyboard()
      If AppInternals\Fullscreen=0; Update the Window if is in windowmode
        WindowEvent()
      EndIf
    Until KeyboardReleased(#PB_Key_Space)
    Spider\Direction=0
    Spider\PosX=tFieldSizeX/2
    Spider\PosY=tFieldSizeY
    Spider\Steps=1
    Spider\isPaint=0
    FieldLeft=100
    ClearList(Bug()) 
    tExit=1
  EndIf
EndProcedure


Procedure createABug()
Protected x.l,y.l,tOK=0
  StartDrawing(ImageOutput(#FieldImage))
  Repeat
    x=AppInternals\GameFrameSize+Random(tFieldSizeX-AppInternals\GameFrameSize*2)
    y=AppInternals\GameFrameSize*2+Random(tFieldSizeY-AppInternals\GameFrameSize*2)
    If Point(x,y)<>NetColor
      tOK=1
    EndIf
  Until tOK=1
  AddElement(Bug())
  Bug()\BugType=1
  Bug()\PosX=x
  Bug()\PosY=y
  Bug()\Steps=Random(level(Actlevel)\MaxBugSpeed-1)+1
  
  If Bug()\Steps=1
    Bug()\spr_bug=spr_Bugs(0)
  Else
    Bug()\spr_bug=spr_Bugs(1)
  EndIf
  
  If Random(1)=0
    Bug()\DirectionX=-1
  Else
    Bug()\DirectionX=1
  EndIf
  If Random(1)=0
    Bug()\DirectionY=-1
  Else
    Bug()\DirectionY=1
  EndIf
  StopDrawing()
EndProcedure


Procedure isBugInNet()
  ForEach bug()
    If Point(bug()\posX,Bug()\posY)=netColor
        DeleteElement(bug())
    EndIf
  Next
EndProcedure


Procedure drawLevel()
Protected tCount.l
  FlipBuffers(0)
  ClearScreen(RGB(255,255,255)) 
  tDC=StartDrawing(ScreenOutput())
  If AppInternals\WithPic
    DrawImage(ImageID(#bgImage), 0+AppInternals\ScreenOffsetX,0+AppInternals\ScreenOffsetY)
    DrawTransparentImage(tDC,ImageID(#FieldImage), 0+AppInternals\ScreenOffsetX, 0+AppInternals\ScreenOffsetY,NetColor) 
  Else
    DrawImage(ImageID(#FieldImage), 0+AppInternals\ScreenOffsetX,0+AppInternals\ScreenOffsetY)
  EndIf
  StopDrawing()
  vsDrawSpriteText(@myFont2,0, 0, Str(100-FieldLeft)+" of "+Str(Level(actLevel)\TargetNetSizePerc))
  vsDrawSpriteText(@myFont2,110,0, "Lives:")
  For tCount=1 To Lives
    DisplayTransparentSprite(#spr_Spider,170+16*tCount,0)
  Next
  DisplayTransparentSprite(#spr_Spider,Spider\Posx-(SpriteWidth(#spr_Spider)/2)+AppInternals\ScreenOffsetX,Spider\PosY-(SpriteHeight(#spr_Spider)/2)+AppInternals\ScreenOffsetY)
  ForEach bug()
   DisplayTransparentSprite(Bug()\spr_Bug,Bug()\PosX-SpriteWidth(Bug()\spr_Bug)/2+AppInternals\ScreenOffsetX,Bug()\PosY-SpriteHeight(Bug()\spr_Bug)/2+AppInternals\ScreenOffsetY)
  Next 
EndProcedure


Procedure GoBug()
Protected tNextX.f,tNextY.f
Protected myColl.strCollision
Protected BugHitsRope.l=0
  StartDrawing(ImageOutput(#FieldImage))
  ForEach bug()
    tNextX=Bug()\PosX+(Bug()\DirectionX*Bug()\Steps)
    tNextY=Bug()\PosY+(Bug()\DirectionY*Bug()\Steps)
    If CheckForCollision (@myColl,Bug()\PosX,Bug()\PosY,tNextX,tNextY,NetColor)
     tNextX=myColl\X
     tNextY=myColl\Y
      If ((Bug()\DirectionX>0 And Bug()\DirectionY<0) Or (Bug()\DirectionX<0 And Bug()\DirectionY<0)) And (Point(tNextX-1,tNextY+1)=NetColor And Point(tNextX+1,tNextY+1)=NetColor)
        Bug()\DirectionY=1
      ElseIf ((Bug()\DirectionX>0 And Bug()\DirectionY>0) Or (Bug()\DirectionX<0 And Bug()\DirectionY>0)) And (Point(tNextX-1,tNextY)=NetColor And Point(tNextX+1,tNextY)=NetColor)
        Bug()\DirectionY=-1
      ElseIf ((Bug()\DirectionX<0 And Bug()\DirectionY<0) Or (Bug()\DirectionX<0 And Bug()\DirectionY>0)) And (Point(tNextX,tNextY-1)=NetColor And Point(tNextX,tNextY+1)=NetColor)
        Bug()\DirectionX=1
      ElseIf ((Bug()\DirectionX>0 And Bug()\DirectionY<0) Or (Bug()\DirectionX>0 And Bug()\DirectionY>0)) And (Point(tNextX,tNextY-1)=NetColor And Point(tNextX,tNextY+1)=NetColor)
        Bug()\DirectionX=-1
      EndIf
    EndIf
    If CheckForCollision (@myColl,Bug()\PosX,Bug()\PosY,tNextX,tNextY,lineColor)
      BugHitsRope=1
    EndIf
    Bug()\PosX=Bug()\PosX+(Bug()\DirectionX*Bug()\Steps)
    Bug()\PosY=Bug()\PosY+(Bug()\DirectionY*Bug()\Steps)
  Next
  StopDrawing()
  If BugHitsRope
    Died()
  EndIf
EndProcedure

Procedure prepareLevel(No.l)
Protected tCount
  Spider\PosX=tFieldSizeX/2
  Spider\PosY=tFieldSizeY
  Spider\Steps=1
  FieldLeft=100
  ClearList(Bug()) 
  For tCount=1 To Level(No)\BugCount
    createABug()
  Next
  LoadImage(#bgImage,"bgNet"+Str(Random(3)+1)+".png")
  ResizeImage(#bgImage, tFieldSizeX, tFieldSizeY)
  
  StartDrawing(ImageOutput(#FieldImage))
  
  Box(0,0,tFieldSizeX,tFieldSizeY,netcolor)
  Box(AppInternals\GameFrameSize,AppInternals\GameFrameSize,tFieldSizeX-AppInternals\GameFrameSize*2,tFieldSizeY-AppInternals\GameFrameSize*2,FieldBGColor)
  StopDrawing()
EndProcedure


Procedure YouGotIt()
  Repeat
    drawlevel()
    vsDrawSpriteText(@myFont1, 50,AppInternals\Screenheight.l/2-50,"You Got IT!!!: ")
    vsDrawSpriteText(@myFont1, 50,AppInternals\ScreenHeight.l/2+60,"Press Space to Continue!")
    ExamineKeyboard()
    If AppInternals\Fullscreen=0; Update the Window if is in windowmode
      WindowEvent()
    EndIf
  Until KeyboardReleased(#PB_Key_Space)
EndProcedure


Procedure GoToNextLevel()
  ActLevel=Actlevel+1
  prepareLevel(Actlevel)

  Repeat
    drawlevel()  
    vsDrawSpriteText(@myFont1, 50,AppInternals\Screenheight.l/2-50,"Next Level: "+Str(ActLevel))
    vsDrawSpriteText(@myFont1, 50,AppInternals\ScreenHeight.l/2-20,"You need "+Str(Level(ActLevel)\TargetNetSizePerc)+" % of the field")
    vsDrawSpriteText(@myFont1, 50,AppInternals\ScreenHeight.l/2,"There are  "+Str(Level(ActLevel)\BugCount)+" bugs in the level")
    vsDrawSpriteText(@myFont1, 50,AppInternals\ScreenHeight.l/2+30,"Have Fun!")
    vsDrawSpriteText(@myFont1, 50,AppInternals\ScreenHeight.l/2+60,"Press Space to Continue!")
    ExamineKeyboard()
    
    If AppInternals\Fullscreen=0; Update the Window if is in windowmode
      WindowEvent()
    EndIf
  Until KeyboardReleased(#PB_Key_Space)
EndProcedure


Procedure inGameLoop()
  Repeat ;Main Loop
   ;Get Time for FPS Calculation. 
    AppInternals\LoopTimeStart = GetTickCount_()
  
  
    If (100-Int(FieldLeft))>=Level(actLevel)\TargetNetSizePerc
      YouGotIt()
      GoToNextLevel()
    EndIf
  
    ExamineKeyboard()
    
    If KeyboardReleased(#PB_Key_Left)
      If Spider\Direction<>2 
        Spider\Direction=4
      ElseIf Spider\Direction=2 And Spider\isPaint=0
        Spider\Direction=4
      EndIf
    ElseIf KeyboardReleased(#PB_Key_Right)
      If Spider\Direction<>4 
        Spider\Direction=2
      ElseIf Spider\Direction=4 And Spider\isPaint=0
        Spider\Direction=2
      EndIf
    ElseIf KeyboardReleased(#PB_Key_Up)
      If Spider\Direction<>3 
        Spider\Direction=1
      ElseIf Spider\Direction=3 And Spider\isPaint=0
        Spider\Direction=1
      EndIf
    ElseIf KeyboardReleased(#PB_Key_Down)
      If Spider\Direction<>1 
        Spider\Direction=3
      ElseIf Spider\Direction=1 And Spider\isPaint=0
        Spider\Direction=3
      EndIf
    EndIf
  
    If KeyboardReleased(#PB_Key_Escape)   ; press Esc to quit
      tExit=1
    EndIf
  
    goBug()
  
    ;If spider moving check everthing
    If Spider\Direction>0
      GoSpider()
    EndIf
  
    drawLevel()
    GoRollText()
    ; calc framerate 
    ;-ForFPS
    If timeGetTime_()-time >= 1000 
      time   = timeGetTime_() 
      FPS    = Frames-1 
      Frames = 1 
    Else 
      Frames+1 
    EndIf 
    
    AppInternals\tTime = AppInternals\GameUpdateFreq - (GetTickCount_() - AppInternals\LoopTimeStart) 
    If AppInternals\tTime > 0 And AppInternals\tTime < AppInternals\GameUpdateFreq 
      Delay(AppInternals\tTime) 
    EndIf  
  
    If AppInternals\Fullscreen=0; Update the Window if is in windowmode
      WindowEvent()
    EndIf
      
  Until tExit=1 ; End of the Main loop
  texit=0
EndProcedure


Procedure loadsprites()
  LoadSprite(#spr_Spider,"Spider1.png")
  TransparentSpriteColor(#spr_Spider, RGB(255,255,255))
  spr_Bugs(0)=LoadSprite(#PB_Any,"Bug1.png")
  TransparentSpriteColor(spr_Bugs(0), RGB(255,255,255))
  spr_Bugs(1)=LoadSprite(#PB_Any,"Bug2.png")
  TransparentSpriteColor(spr_Bugs(1), RGB(255,255,255))
  vsLoadSpriteFont(@myFont1,"font1.png",12,20)
  vsLoadSpriteFont(@myFont2,"font2.png",12,20)
  LoadSprite(#img_GameOver,"GameOver.png")
  TransparentSpriteColor(#img_GameOver, RGB(255,255,255))
EndProcedure


Procedure HelpScreen()
  Repeat  
    FlipBuffers(0)
    ClearScreen(RGB(255,255,255) )
    vsDrawSpriteText(@myFont1, 10,30,"Target of the Game is that you help your spider")
    vsDrawSpriteText(@myFont1, 10,60,"to spin the net.")
    vsDrawSpriteText(@myFont1, 10,90,"Do not touch your own rope because it will rip off.")
    
    vsDrawSpriteText(@myFont1, 10,120,"Do not let the bugs hit your rope because it")
    vsDrawSpriteText(@myFont1, 10,150,"will rip off.")
    vsDrawSpriteText(@myFont1, 10,180,"You will get extra points if you catch a bug.")
    vsDrawSpriteText(@myFont1, 10,210,"If you spin more than 25 percent at once you will")
    vsDrawSpriteText(@myFont1, 10,240,"get an extra Live.")

    ExamineKeyboard()
    If AppInternals\Fullscreen=0; Update the Window if is in windowmode
      WindowEvent()
    EndIf
    
  Until KeyboardReleased(#PB_Key_Escape)
EndProcedure


Procedure OptionScreen()
Protected mItem.l=1,tCount.l,tStyle.l,tExit.l=0
Protected tFullScreen.l,tBit.l
Dim Items.s(20)
  tFullScreen=AppInternals\Fullscreen
  tBit=AppInternals\ScreenDeep
  Repeat
    FlipBuffers(0)
    ClearScreen(0) 
    tDC=StartDrawing(ScreenOutput())
    DrawImage(ImageID(#img_StartImage), 0,0)
    StopDrawing()
    ;vsDrawSpriteText(@myFont2, 50,AppInternals\ScreenHeight.l/2+60,"Press Space to Start!")    
    If tFullscreen=1
      Items(1)="Fullscreen"
    Else
      Items(1)="Window"
    EndIf
    
    Items(2)="Color:"+Str(tBit)+" bit"
    If AppInternals\WithPic=1
      Items(3)="Back ground picture: on"
    Else
      Items(3)="Back ground picture: off"
    EndIf
    Items(4)="Exit"
    
    For tCount=1 To 4
      If tCount=mItem
        tStyle=1
      Else
        tStyle=0
      EndIf
    ChooseTextStyle(@myFont2,50,AppInternals\ScreenHeight.l/2+30*(tCount-1),Items(tCount),tStyle)
    Next 
    
    ExamineKeyboard()
    If AppInternals\Fullscreen=0; Update the Window if is in windowmode
      WindowEvent()
    EndIf
    If KeyboardReleased(#PB_Key_Escape)
      tExit=1
    ElseIf KeyboardReleased(#PB_Key_Up)
     mItem=mItem-1
    ElseIf KeyboardReleased(#PB_Key_Down)
     mItem=mItem+1
    ElseIf KeyboardReleased(#PB_Key_Space) Or KeyboardReleased(#PB_Key_Return)
      Select mItem
        Case 1 
          If tFullscreen=1
            tFullscreen=0
          Else
            tFullscreen=1
          EndIf
        Case 2
           If tBit=16
              tBit=24
           ElseIf tBit=24
              tBit=32
           ElseIf tBit=32
              tBit=16
           EndIf
        Case 3
          If AppInternals\WithPic=1
            AppInternals\WithPic=0
          Else
            AppInternals\WithPic=1
          EndIf
        Case 4
          texit=1    
      EndSelect
    EndIf
    If mItem=0:mItem=4:EndIf    
    If mItem=5:mItem=1:EndIf    

    Delay(100)
  Until tExit=1
 
  If tBit<>AppInternals\ScreenDeep Or  tfullscreen<>AppInternals\Fullscreen
    If  AppInternals\Fullscreen=1
      CloseScreen()
    Else
      CloseWindow(#wnd_Main)
    EndIf
    AppInternals\Fullscreen=tFullScreen
    AppInternals\ScreenDeep=tBit
    If  AppInternals\Fullscreen=1
     OpenScreen(AppInternals\ScreenWidth,AppInternals\ScreenHeight,AppInternals\ScreenDeep,"Mr. Spider")
    loadsprites()
    Else
      If OpenWindow(#wnd_Main, 1, 1, AppInternals\WindowWidth, AppInternals\WindowHeight, "Mr. Spider",  #PB_Window_SystemMenu | #PB_Window_SizeGadget | #PB_Window_TitleBar )
        OpenWindowedScreen(WindowID(#wnd_Main),0,0,AppInternals\ScreenWidth,AppInternals\ScreenHeight,1,0,0)
      EndIf
      loadsprites()
    EndIf
  EndIf   
EndProcedure


Procedure StartScreen()
Protected mItem.l=1,tCount.l,tStyle.l
Dim Items.s(20)

  Repeat
    FlipBuffers(0)
    ClearScreen(0) 
    tDC=StartDrawing(ScreenOutput())
    DrawImage(ImageID(#img_StartImage), 0,0)
    StopDrawing()
    ;vsDrawSpriteText(@myFont2, 50,AppInternals\ScreenHeight.l/2+60,"Press Space to Start!")    
    
    Items(1)="Start Game"
    Items(2)="Help"
    Items(3)="Options"
    Items(4)="Exit"
    
    For tCount=1 To 4
      If tCount=mItem
        tStyle=1
      Else
        tStyle=0
      EndIf
      ChooseTextStyle(@myFont2,50,AppInternals\ScreenHeight.l/2+30*(tCount-1),Items(tCount),tStyle)
    Next    
    
    ExamineKeyboard()
    If AppInternals\Fullscreen=0; Update the Window if is in windowmode
      WindowEvent()
    EndIf
    If KeyboardReleased(#PB_Key_Escape)
      tExit=1
    ElseIf KeyboardReleased(#PB_Key_Up)
     mItem=mItem-1
    ElseIf KeyboardReleased(#PB_Key_Down)
     mItem=mItem+1
    ElseIf KeyboardReleased(#PB_Key_Space) Or KeyboardReleased(#PB_Key_Return)
      Select mItem
        Case 1 
          Lives=3
          ActLevel=0
          GoToNextLevel()
          inGameLoop()
        Case 2
          HelpScreen()
        Case 3
          optionscreen()
        Case 4
          texit=1    
      EndSelect
    EndIf
    If mItem=0:mItem=4:EndIf    
    If mItem=5:mItem=1:EndIf    

    Delay(100)
  Until tExit=1
EndProcedure



UsePNGImageDecoder() 
InitKeyboard()
InitSprite()

Open_wnd_Main()

loadsprites()

LoadImage(#img_StartImage,"StartScreen.png")
CreateImage(#FieldImage,tFieldSizeX,tFieldSizeY)

InitGameTimer() 
time = timeGetTime_() 

StartScreen()

;-ForFPS
StopGameTimer()
End
; IDE Options = PureBasic 4.20 (Windows - x86)
; CursorPosition = 978
; FirstLine = 654
; Folding = BAshy
; Executable = MrSpider\MrSpider.exe
; DisableDebugger
; Watchlist = CheckForCollision()>x2;CheckForCollision()>y2